//+------------------------------------------------------------------+
//|                                                      Program.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include <EasyAndFastGUI\Controls\WndEvents.mqh>
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
class CProgram : public CWndEvents
  {
protected:
   //--- 
   CWindow           m_window;
   //---      
   CMenuBar          m_menubar;
   CContextMenu      m_mb_contextmenu1;
   CContextMenu      m_mb_contextmenu2;
   CContextMenu      m_mb_contextmenu3;
   CContextMenu      m_mb_contextmenu4;
   //---  
   CStatusBar        m_status_bar;
   //--- 
   CTabs             m_tabs;
   //---  
   CSimpleButton     m_simple_button1;
   CSimpleButton     m_simple_button2;
   CSimpleButton     m_simple_button3;
   //---   
   CIconButton       m_icon_button1;
   //---  
   CSplitButton      m_split_button1;
   //---    1
   CButtonsGroup     m_buttons_group1;
   //---  - 1
   CRadioButtons     m_radio_buttons1;
   //---     1
   CIconButtonsGroup m_icon_buttons_group1;
   //--- 
   CListView         m_listview1;
   //---  
   CProgressBar      m_progress_bar;

   //---    
   CLabelsTable      m_labels_table;

   //---    
   CTable            m_table;

   //---  
   CCanvasTable      m_canvas_table;

   //---  
   CLineGraph        m_line_chart;

   //---  
   CSpinEdit         m_spin_edit1;
   //--- -
   CComboBox         m_combobox1;
   //---  
   CTreeView         m_treeview;

   //--- -
   CCheckBox         m_checkbox1;
   //--- -   
   CCheckBoxEdit     m_checkboxedit1;
   //--- -  -
   CCheckComboBox    m_checkcombobox1;
   //---  
   CFileNavigator    m_navigator;

   //--- 
   CCalendar         m_calendar1;
   //---  
   CDropCalendar     m_drop_calendar1;
   //--- 
   CSlider           m_slider1;
   CDualSlider       m_dual_slider1;
   //---  
   CSeparateLine     m_sep_line;
   //---       
   CColorButton      m_color_button1;

   //---  2
   CWindow           m_window2;
   //---  
   CColorPicker      m_color_picker;

#define SERIES_TOTAL 2
   //---    
   struct Series
     {
      double            data[];      //   
      double            data_temp[]; //    
     };
   Series            m_series[];

   //--- (1)   (2)  
   string            m_series_name[];
   color             m_series_color[];
   //---
public:
                     CProgram(void);
                    ~CProgram(void);
   //--- /
   void              OnInitEvent(void);
   void              OnDeinitEvent(const int reason);
   //--- 
   void              OnTimerEvent(void);
   //---   
   virtual void      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);

   //---    
   bool              CreateGUI(void);
   //---
protected:
   //--- 
   bool              CreateWindow(const string text);
   //---  
   bool              CreateMenuBar(const int x_gap,const int y_gap);
   bool              CreateMBContextMenu1(void);
   bool              CreateMBContextMenu2(void);
   bool              CreateMBContextMenu3(void);
   bool              CreateMBContextMenu4(void);
   //---  
   bool              CreateStatusBar(const int x_gap,const int y_gap);
   //--- 
   bool              CreateTabs(const int x_gap,const int y_gap);
   //---  
   bool              CreateSimpleButton1(const int x_gap,const int y_gap,const string text);
   bool              CreateSimpleButton2(const int x_gap,const int y_gap,const string text);
   bool              CreateSimpleButton3(const int x_gap,const int y_gap,const string text);
   //---   
   bool              CreateIconButton1(const int x_gap,const int y_gap,const string text);
   //---  
   bool              CreateSplitButton1(const int x_gap,const int y_gap,const string text);
   //---    1
   bool              CreateButtonsGroup1(const int x_gap,const int y_gap);
   //---  - 1
   bool              CreateRadioButtons1(const int x_gap,const int y_gap);
   //---     1
   bool              CreateIconButtonsGroup1(const int x_gap,const int y_gap);
   //---  1
   bool              CreateListView1(const int x_gap,const int y_gap);
   //---  
   bool              CreateProgressBar(const int x_gap,const int y_gap);
   //---    
   bool              CreateLabelsTable(const int x_gap,const int y_gap);
   //---    
   bool              CreateTable(const int x_gap,const int y_gap);
   //---  
   bool              CreateCanvasTable(const int x_gap,const int y_gap);
   //---  
   bool              CreateLineChart(const int x_gap,const int y_gap);
   //---  
   bool              CreateSpinEdit1(const int x_gap,const int y_gap,const string text);
   //--- - 1
   bool              CreateComboBox1(const int x_gap,const int y_gap,const string text);
   //---  
   bool              CreateTreeView(const int x_gap,const int y_gap);

   //--- -
   bool              CreateCheckBox1(const int x_gap,const int y_gap,const string text);
   //--- -   
   bool              CreateCheckBoxEdit1(const int x_gap,const int y_gap,const string text);
   //--- -  -
   bool              CreateCheckComboBox1(const int x_gap,const int y_gap,const string text);
   //---  
   bool              CreateFileNavigator(const int x_gap,const int y_gap);
   //--- 
   bool              CreateCalendar1(const int x_gap,const int y_gap);
   //---  
   bool              CreateDropCalendar1(const int x_gap,const int y_gap,const string text);
   //--- 
   bool              CreateSlider1(const int x_gap,const int y_gap,const string text);
   bool              CreateDualSlider1(const int x_gap,const int y_gap,const string text);
   //---  
   bool              CreateSepLine(const int x_gap,const int y_gap);
   //---     
   bool              CreateColorButton1(const int x_gap,const int y_gap,const string text);

   //---  2
   bool              CreateWindow2(const string text);
   //---  
   bool              CreateColorPicker(const int x_gap,const int y_gap);
   //---
protected:
   //---    
   void              ResizeDataArrays(void);
   //---     
   void              InitArrays(void);
   //---  
   void              CalculateSeries(void);
   //---    
   void              AddSeries(void);
   //---    
   void              UpdateSeries(void);
   //---     
   void              CalculateYOffset(void);
  };
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
#include "MainWindow.mqh"
//+------------------------------------------------------------------+
//| Constructor                                                      |
//+------------------------------------------------------------------+
CProgram::CProgram(void)
  {
//---    
   ::ArrayResize(m_series,SERIES_TOTAL);
   ::ArrayResize(m_series_name,SERIES_TOTAL);
   ::ArrayResize(m_series_color,SERIES_TOTAL);
//---    
   for(int i=0; i<SERIES_TOTAL; i++)
      m_series_name[i]="Series "+string(i+1);
//---    
   m_series_color[0]=clrCornflowerBlue;
   m_series_color[1]=clrRed;
  }
//+------------------------------------------------------------------+
//| Destructor                                                       |
//+------------------------------------------------------------------+
CProgram::~CProgram(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void CProgram::OnInitEvent(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void CProgram::OnDeinitEvent(const int reason)
  {
//---  
   CWndEvents::Destroy();
  }
//+------------------------------------------------------------------+
//|                                                            |
//+------------------------------------------------------------------+
void CProgram::OnTimerEvent(void)
  {
   CWndEvents::OnTimerEvent();
//---  
   static int count1=0;
   if(m_simple_button3.IsPressed())
     {
      int total=1000;
      count1=(count1>=total) ? 0 : count1+=5;
      m_progress_bar.Update(count1,total);
     }
   else
      count1=0;
//---    
   static int count2=0;
   if(count2<300)
     {
      count2+=TIMER_STEP_MSC;
      return;
     }
//---  
   count2=0;
//---     
   m_status_bar.ValueToItem(1,TimeToString(TimeLocal(),TIME_DATE|TIME_SECONDS));
//---  
   CalculateSeries();
//---     
   CalculateYOffset();
//---   
   UpdateSeries();
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void CProgram::OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//---   
   if(id==CHARTEVENT_CUSTOM+ON_WINDOW_UNROLL)
     {
      //---   ,    
      if(m_simple_button3.IsPressed())
         m_progress_bar.Show();
      //---
      return;
     }
//---      
   if(id==CHARTEVENT_CUSTOM+ON_CHANGE_COLOR)
     {
      //---   
      if(lparam==m_color_picker.Id())
        {
         //---     
         if(sparam==m_color_button1.LabelText())
           {
            //---   ,      ( )
            return;
           }
        }
      return;
     }
//---    
   if(id==CHARTEVENT_CUSTOM+ON_CLICK_BUTTON)
     {
      //---     
      if(lparam==m_simple_button3.Id())
        {
         //---           
         if(m_simple_button3.IsPressed())
            m_progress_bar.Show();
         else
            m_progress_bar.Hide();
         //---
         return;
        }
      //---         
      if(sparam==m_color_button1.LabelText())
        {
         //---   ,       
         m_color_picker.ColorButtonPointer(m_color_button1);
         return;
        }
      //---
      return;
     }
//---    
   if(id==CHARTEVENT_CUSTOM+ON_WINDOW_CHANGE_SIZE)
     {
      //---   
      UpdateSeries();
      return;
     }
  }
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
bool CProgram::CreateGUI(void)
  {
//---  
   if(!CreateWindow("EXPERT PANEL"))
      return(false);
//---  
   if(!CreateMenuBar(1,20))
      return(false);
//---  
   if(!CreateMBContextMenu1())
      return(false);
   if(!CreateMBContextMenu2())
      return(false);
   if(!CreateMBContextMenu3())
      return(false);
   if(!CreateMBContextMenu4())
      return(false);
//---   
   if(!CreateStatusBar(1,285))
      return(false);
//--- 
   if(!CreateTabs(0,43))
      return(false);
//---  
   if(!CreateSimpleButton1(7,70,"Simple Button 1"))
      return(false);
   if(!CreateSimpleButton2(150,70,"Simple Button 2"))
      return(false);
   if(!CreateSimpleButton3(7,95,"Simple Button 3"))
      return(false);
//---   
   if(!CreateIconButton1(7,120,"Icon Button 1"))
      return(false);
//---  
   if(!CreateSplitButton1(150,120,"Split Button 1"))
      return(false);
//---    1
   if(!CreateButtonsGroup1(7,145))
      return(false);
//---  - 1
   if(!CreateRadioButtons1(7,170))
      return(false);
//---     1
   if(!CreateIconButtonsGroup1(7,193))
      return(false);
//--- 
   if(!CreateListView1(300,70))
      return(false);

//---  
   if(!CreateProgressBar(5,289))
      return(false);
//---    
   if(!CreateLabelsTable(1,63))
      return(false);
//---    
   if(!CreateTable(1,63))
      return(false);
//---   
   if(!CreateCanvasTable(1,63))
      return(false);
//---  
   if(!CreateLineChart(2,64))
      return(false);

//---  
   if(!CreateSpinEdit1(7,68,"Spin Edit 1:"))
      return(false);
//--- -
   if(!CreateComboBox1(140,68,"Combobox 1:"))
      return(false);
//---   
   if(!CreateTreeView(2,90))
      return(false);

//--- -
   if(!CreateCheckBox1(7,68,"Checkbox 1"))
      return(false);
//--- -   
   if(!CreateCheckBoxEdit1(105,68,"Checkbox Edit 1:"))
      return(false);
//--- -  -
   if(!CreateCheckComboBox1(295,68,"CheckCombobox 1:"))
      return(false);
//---   
   if(!CreateFileNavigator(2,90))
      return(false);

//--- 
   if(!CreateCalendar1(10,71))
      return(false);
//---  
   if(!CreateDropCalendar1(188,72,"Drop calendar 1: "))
      return(false);
//--- 
   if(!CreateSlider1(189,108,"Slider 1:"))
      return(false);
   if(!CreateDualSlider1(10,238,"Dual Slider 1:"))
      return(false);
//---  
   if(!CreateSepLine(189,170))
      return(false);
//---     
   if(!CreateColorButton1(188,200,"Color button 1:"))
      return(false);

//---   2   
   if(!CreateWindow2("Color picker"))
      return(false);
//---  
   if(!CreateColorPicker(1,20))
      return(false);

//---    
   m_tabs.ShowTabElements();
   return(true);
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void CProgram::ResizeDataArrays(void)
  {
   int size_of_series=1000;
//---
   for(int s=0; s<SERIES_TOTAL; s++)
     {
      //---    
      ::ArrayResize(m_series[s].data,size_of_series);
      ::ArrayResize(m_series[s].data_temp,size_of_series);
     }
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
void CProgram::InitArrays(void)
  {
   for(int s=0; s<SERIES_TOTAL; s++)
     {
      int size_of_series=::ArraySize(m_series[s].data_temp);
      //---
      for(int i=0; i<size_of_series; i++)
        {
         if(i==0)
           {
            if(s>0)
               m_series[s].data_temp[i]=m_series[s-1].data_temp[i]+1;
            else
               m_series[s].data_temp[i]=1;
           }
         else
            m_series[s].data_temp[i]=m_series[s].data_temp[i-1]+1;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void CProgram::CalculateSeries(void)
  {
   for(int s=0; s<SERIES_TOTAL; s++)
     {
      int size_of_series=::ArraySize(m_series[s].data_temp);
      //---
      for(int i=0; i<size_of_series; i++)
        {
         m_series[s].data_temp[i]+=1;
         //---
         int rand_value =rand()%1000;
         int max_or_min =(bool(rand()%2))? rand_value : -rand_value;
         //---
         if(i==0)
            m_series[s].data[i]=0;
         else
            m_series[s].data[i]=m_series[s].data[i-1]+max_or_min;
        }
     }
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
void CProgram::AddSeries(void)
  {
   for(int s=0; s<SERIES_TOTAL; s++)
      m_line_chart.SeriesAdd(m_series[s].data,m_series_name[s],m_series_color[s]);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void CProgram::UpdateSeries(void)
  {
   for(int s=0; s<SERIES_TOTAL; s++)
      m_line_chart.SeriesUpdate(s,m_series[s].data,m_series_name[s],m_series_color[s]);
  }
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+
void CProgram::CalculateYOffset(void)
  {
   double max_value =0.0;
   double min_value =0.0;
//---      
   for(int s=0; s<SERIES_TOTAL; s++)
     {
      max_value=fmax(max_value,m_series[s].data[ArrayMaximum(m_series[s].data)]);
      min_value=fmin(min_value,m_series[s].data[ArrayMinimum(m_series[s].data)]);
     }
//---  
   double range    =max_value-min_value;
   double y_offset =range*0.05;
//---   
   m_line_chart.VScaleParams(max_value+y_offset,min_value-y_offset,4);
  }
//+------------------------------------------------------------------+
